﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace ButtonToolBlinkingIndicator89640
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraButton1.Click += new EventHandler(ultraButton1_Click);
            ultraButton2.Click += new EventHandler(ultraButton2_Click);

            timer.Tick += new EventHandler(timer_Tick);

            //Set the duration in milliseconds between each AplhaLevel transitional phase, (higher the value, the slower the blinking frequency)
            timer.Interval = 25;
        }

        //Create an instance of the .NET Timer object
        Timer timer = new Timer();
        //Create a variable to monitor the number of timer ticks 
        int tickNum = 11;
        //Set a range for tickNum, this range will be used as lower and upper limits for AlphaLevel values
        int tickMin = 11; //Always the same as tickNum
        int tickMax = 251; //The max value may be any number divisible by the initial value of tickNum and less than 255; which is the maximum allowed value for
        //the AplhaLevel property

        //Create a bool to reference the current logic cycle; this will allow us to implement a flip-flop logic, to switch between transparent and opaque cycles
        bool cycleReference = false;
        //Create a variable to store a constant which represents the change in the AlphaLevel, per phase for both cycles
        int phaseConstant = 10;

        void timer_Tick(object sender, EventArgs e)
        {
            //Check to see if tickNum's value is also its minimum value 
            if (tickNum == tickMin)
            {
                //if so, apply the first increment to tickNum
                tickNum += phaseConstant;
                //Invert reference bool to start the first half of the flip-flop logic
                if (tickNum > tickMin) cycleReference = true;
            }

            //Check to see if the tickNum is equal to the upper limit that we have set for the AlphaLevel
            if (tickNum == tickMax)
            {
                tickNum -= phaseConstant;
                //Invert reference bool to start the second half of the flip-flop logic
                if (tickNum < tickMax) cycleReference = false;
            }

            //Check for the current cycle; True, indicates a shift to a gradually more opaque appearance and False indicates a shift to a gradually more
            //transparent appearance
            if (cycleReference) tickNum += phaseConstant;
            else tickNum -= phaseConstant;

            //Set the AlphaLevel for the desired control(s) to reflect the current tickNum value
            ultraToolbarsManager1.Ribbon.Tabs[0].Groups[0].Tools[0].InstanceProps.AppearancesSmall.Appearance.AlphaLevel = (short)tickNum;

            //Note on InstanceProps.AppearancesSmall vs InstanceProps.AppearancesLarge
                //These appearances described the current display format of the tool. If you intend to display the tool using its Large appearance, you will
                //also need to modify the above code as well, to reflect this state
                    //i.e. ultraToolbarsManager1.Ribbon.Tabs[0].Groups[0].Tools[0].InstanceProps.AppearancesLarge.Appearance.AlphaLevel = (short)tickNum;
                    //Note that the default appearance for the ButtonTool reflects AppearancesSmall
        }   

        void ultraButton2_Click(object sender, EventArgs e)
        {
            //Off
            timer.Stop();

            //Restore normal appearance to ButtonTool
            ultraToolbarsManager1.Ribbon.Tabs[0].Groups[0].Tools[0].InstanceProps.AppearancesSmall.Appearance.AlphaLevel = 255;

            //Reset tickNum back to its initial value
            tickNum = tickMin;
        }

        void ultraButton1_Click(object sender, EventArgs e)
        {
            //On
            timer.Start();
        }
    }
}
